Subject: RE: [Speechsc] Problem with draft-6 RECOGNIZEcommandandtest/uri-listcontent type

From: "Shanmugham, Saravanan" <[email-masked]>
Date: Wed, 15 Jun 2005 11:53:23 -0700

I am fine with the idea. 
Would you be able to propose a content-type registration section for
this content-type. 
We could add it to the current list of registrations and retire the
one-of header.

Sarvi 

     -----Original Message-----
     From: Wyss, Felix [mailto:[email-masked]] 
     Sent: Wednesday, June 15, 2005 11:37 AM
     To: Dave Burke; Shanmugham, Saravanan; David R. Oran
     Cc: [email-masked]; Bennett, Patrick
     Subject: RE: [Speechsc] Problem with draft-6 
     RECOGNIZEcommandandtest/uri-listcontent type
     
     I think that's a terrible abuse of the MIME types!  The 
     weight parameter controls the weight with which the 
     grammar is considered in a particular recognition 
     operation.  That has *absolutely nothing* to do with the 
     type of the grammar.  Using a MIME-type parameter for this 
     would be akin to controlling the text size of an HTML page 
     through its MIME type.
     
     I personally don't really have a problem with using an 
     inline "one-of"
     grammar.  However, if that's considered too much hassle 
     for the clients, what about introducing a content type 
     text/grammar-refs for the RECOGNIZE command?  Each line of 
     the body would be a URI enclosed in angle brackets, 
     followed by a colon and a list of parameters.  For
     example: 
      
     Channel-Identifier: 123456789012345@speechrecog
     N-Best-List-Length: 3
     Content-Type: text/grammar-refs
     Content-Length: xxx
                
     <http://myserver/grammars/form1.gram>
     <http://myserver/grammars/form2.gram>:weight=0.85
     <http://myserver/grammars/universals.gram>:weight=0.75

     Felix
     
     > -----Original Message-----
     > From: [email-masked] 
     [mailto:[email-masked]] On 
     > Behalf Of Dave Burke
     > Sent: Wednesday, June 15, 2005 04:05
     > To: Shanmugham, Saravanan; David R. Oran
     > Cc: [email-masked]; Bennett, Patrick
     > Subject: Re: [Speechsc] Problem with draft-6
     RECOGNIZEcommandandtest/uri-
     > listcontent type
     > 
     > I did some quick research into extending MIME headers 
     and noted the
     > following:
     >     - RFC2045 allows new Content-* extensions
     >     - No IANA considerations apply
     >     - Seems like new headers introduced in the past have 
     had their own
     RFC
     > (e.g.  RFC2912 and RFC3803).
     > 
     > We would be defining a new MIME header inside the MRCP
     specification...
     > 
     > A slicker approach could be to request to the author of 
     the I-D that 
     > defines the application/srgs+xml media type
     >
     (http://www.ietf.org/internet-drafts/draft-froumentin-voice
     -mediatypes-
     > 02.txt)
     > to add an optional parameter called 'weight' so we could 
     use something
     > like:
     > 
     >     Content-Type: application/srgs+xml;weight=0.75
     > 
     > The values could take on the VoiceXML definition, which 
     I believe has
     the
     > right amount of generality.
     > 
     > I defer to more experienced IETFeers on whether either of these
     approaches
     > appear tenable.
     > 
     > Dave
     > 
     > ----- Original Message -----
     > From: "Shanmugham, Saravanan" <[email-masked]>
     > To: "Dave Burke" <[email-masked]>; "David R. Oran"
     > <[email-masked]>
     > Cc: <[email-masked]>; "Bennett, Patrick" 
     <[email-masked]>
     > Sent: Tuesday, June 14, 2005 8:24 PM
     > Subject: RE: [Speechsc] Problem with draft-6 RECOGNIZE 
     > commandandtest/uri-listcontent type
     > 
     > 
     > I am fine with Option iii, but the we would be trying to 
     extend MIME 
     > headers which I am not sure if its extenisble or what 
     the procedure to 
     > define new MIME-headers are. Could find any good examples.
     > 
     > So I chose the next best thing which was to use a 
     <One-of> rule id 
     > approach.
     > 
     > Sarvi
     > 
     >      -----Original Message-----
     >      From: [email-masked]
     >      [mailto:[email-masked]] On Behalf Of Dave Burke
     >      Sent: Tuesday, June 14, 2005 9:41 AM
     >      To: David R. Oran
     >      Cc: [email-masked]; Bennett, Patrick
     >      Subject: Re: [Speechsc] Problem with draft-6 RECOGNIZE
     >      commandandtest/uri-listcontent type
     > 
     >      To be clear, I think there are two issues:
     >      A. How to word the precedence when input matches more than
     >      one active grammar?
     >      B. How to specify a weight for a complete grammar? (see
     >      http://www1.ietf.org/mail-archive/web/speechsc/current/msg0
     >      1023.html)
     > 
     >      For A, how about appending the sentence in 1. and 2. so
     >      that we get:
     > 
     >      ...the order of inclusion controls the corresponding
     >      precedence for the grammars during recognition should the
     >      input match more than one active grammar.
     > 
     >      For B, which point 3 addresses, there are three options
     discussed:
     >      (i) Use the One-Of-Rule-Id-URI mechanism below
     >      (ii) Add an informative note that a <one-of> grammar can
     >      be used to apply weights to grammars (One-Of-Rule-Id-URI
     >      is unnecessary )
     >      (iii) Go with Jeff's idea of adding a new header to 
     a MIME part
     >      (http://www1.ietf.org/mail-archive/web/speechsc/current/msg
     >      01102.html) Small refinement though, the header should be
     >      called Content-Grammar-Weight to fit RFC2045's extension
     mechanism
     > 
     >      My preference is for (iii) over (ii) because if my MRCP
     >      client runs VoiceXML then I'm going to have to handle
     >      cases when <grammar> has a weight attribute and build up a
     >      <one-of> grammar. This is just annoying complexity for the
     client.
     > 
     >      Dave
     > 
     > 
     >      ----- Original Message -----
     >      From: "David R. Oran" <[email-masked]>
     >      To: "Dave Burke" <[email-masked]>
     >      Cc: <[email-masked]>; "Bennett, Patrick"
     >      <[email-masked]>
     >      Sent: Tuesday, June 14, 2005 5:02 PM
     >      Subject: Re: [Speechsc] Problem with draft-6 RECOGNIZE
     >      command andtest/uri-listcontent type
     > 
     > 
     >      I agree with Dave, but I also believe the current text is
     >      quite torturous and prone to misinterpretation. I had held
     >      off screwing around with it because of my shaky
     >      understanding of the "one-of-rule- id" stuff but now that
     >      I think I can get it right I've taken a whack at it.
     > 
     >      This is what the in-progress version of the spec says:
     > 
     >      The RECOGNIZE request uses the message body to specify the
     >      grammars applicable to the request. The active grammar(s)
     >      for the request can be specified in one of 3 ways.
     > 
     >      1. The grammer may be placed directly in the message body
     >      using MIME content. If more than one grammar is included
     >      in the body, the order of inclusion controls the
     >      corresponding precedence for the grammars during 
     recognition.
     >      2. The body may contain a list of grammar URIs specified
     >      in a mime- content of type text/uri-list. The order of the
     >      URIs determines the corrensponding precedence for the
     >      grammars during recognition.
     >      3. The active grammar among a set of grammars can
     >      specified using a One-Of-Rule-Id-URI header in the
     >      message. This header (see Section
     >      9.4.24 (One-Of-Rule-Id-URI)) refers to a specific <one-of>
     >      rule-id contained in the grammar (or grammars) specified
     >      in the body of the message.
     > 
     >      Are further adjustments needed?
     > 
     > 
     >      On Jun 14, 2005, at 11:25 AM, Dave Burke wrote:
     > 
     >      > The precedence is not related to weighting. The text
     >      here covers  the
     >      > case if you had two grammars say gram1.grxml and
     >      gram2.grxml  both of
     >      > which recognise the token "speech" but return a
     >      different  semantic
     >      > interpretation. If gram2.grxml follows gram1.grxml in
     >      the  uri-list
     >      > then it is gram1.grxml that is matched and it is  
     gram1.grxml's
     >      > semantic interpretation result that is returned 
     in  the NLSML.
     >      >
     >      > This is also required for VoiceXML 2.x behaviour 
     (see http://
     >      > www.w3.org/TR/2004/REC-voicexml20-20040316/#dml3.1.4).
     >      >
     >      > Dave
     >      > ----- Original Message -----
     >      > From: Bennett, Patrick
     >      > To: [email-masked]
     >      > Sent: Tuesday, June 14, 2005 4:09 PM
     >      > Subject: [Speechsc] Problem with draft-6 RECOGNIZE
     >      command and test/
     >      > uri-listcontent type
     >      >
     >      > According to the latest draft on page 89:
     >      >
     >      >
     >      >    ...The RECOGNIZE method MUST carry the 
     grammars that need to
     > be
     >      >
     >      >    activated for that RECOGNIZE method, in its 
     message body.
     The
     >      >
     >      >    grammars that need to be activated can be specified
     >      in one of 3
     >      >
     >      >    ways. The grammar content could be specified as a
     >      mime-content in
     >      >
     >      >    the message body. It could be a simple list of 
     grammar URIs
     >      >
     >      >    specified in a mime-content of type text/uri-list, in
     >      which case
     >      > the
     >      >
     >      >    order of the URI refer to the precedence order of the
     grammars
     >      >
     >      >    during the recognize. ...
     >      >
     >      >
     >      > The problem here is the statement "in which case the
     >      order of the  URI
     >      > refer to the precedence order of the   grammars during
     >      the  recognize."
     >      >
     >      > Well, what is the EXACT precedence?  Shouldn't each of
     >      the grammars
     >      > be considered as equally weighted alternatives?
     >      Ideally, all must  be
     >      > weighted equally unless a specific weight parameter was
     >      specified
     >      > with each URI.
     >      >
     >      > As currently specified, this part of the specification
     >      is basically
     >      > worthless.  No MRCP client would ever send multiple URIs
     >      to an MRCP
     >      > server via a uri-list since the weighting applied to
     >      each grammar  is
     >      > completely undefined.
     >      >
     >      > This really needs to be corrected.
     >      >
     >      >
     >      > Patrick Bennett
     >      >
     >      >
     >      >
     >      > _______________________________________________
     >      > Speechsc mailing list
     >      > [email-masked]
     >      > https://www1.ietf.org/mailman/listinfo/speechsc
     >      > _______________________________________________
     >      > Speechsc mailing list
     >      > [email-masked]
     >      > https://www1.ietf.org/mailman/listinfo/speechsc
     >      >
     > 
     >      _______________________________________________
     >      Speechsc mailing list
     >      [email-masked]
     >      https://www1.ietf.org/mailman/listinfo/speechsc
     > 
     > 
     >      _______________________________________________
     >      Speechsc mailing list
     >      [email-masked]
     >      https://www1.ietf.org/mailman/listinfo/speechsc
     > 
     > 
     > 
     > _______________________________________________
     > Speechsc mailing list
     > [email-masked]
     > https://www1.ietf.org/mailman/listinfo/speechsc

_______________________________________________
Speechsc mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/speechsc

---

From: "David R. Oran" <[email-masked]>
Date: Wed, 15 Jun 2005 15:34:33 -0400

I'm cool with this too. Let's give a bit more time to see if anyone  
violently objects. Don't wait to supply text though!